function R = dh_R(theta, omega, bondL)

%% dh_R = Rot1(omega)*Rot3(theta)*T([0 0 bondL])

ct = cos(theta); st = sin(theta);
co = cos(omega); so = sin(omega);
R = [ct -st 0 0
    st*co ct*co -so -bondL*so
    st*so ct*so  co  bondL*co
    0  0  0  1];