%There are several representations that are active here
%
%1. table of backbone atom residue#s & coordinates 
%   Let's start with N,Ca,C, although we may 
%   want to access starting with and index after the first.
%   atomType = {'N'; 'Ca'; 'C'}{(index%3)+1}
%
%2. table of DH parameters for backbone N,Ca,C
%
%3. table of Ca.p1.p2 coordinates, derived from 
%
%4. table of DH parameters for Ca.p1.p2
%
%5. point lists with side atoms
%
%6. point lists with side atoms & derivatives
%
% Deltas apply to DH parameters for backbone.
%
% ik requires DH for Ca.p1.p2 and returns table of solution (phi,psi)s. 
% these must be classified according to branches,
% then derivatives may be estimated and kins plotted.
%
% The functions that we need are therefore, 
% conversions from one rep to another:
% 1 <--> 2, 1 <--> 3, (or 1->2->3->1)
% 3 <--> 4 (same as 1<-->2?), 
% 1 -> 5 
% 


