% finding maximum deviation from tau2 perturbation of central 
x = load('2dri.mat')
m = x.rbp
v5 = [];
mymax = 0;
for l = min(m(:,1))+2:max(m(:,1))-2
    loop = chooseLoop(m,l,'cb');
    w = wiggleLoop(loop,'tau2',1);
    ik = iksolnLoop(w); % solve for all phi/psi to match w.original placement
    s = singleBranch(ik); % eliminate all solutions except those in the ik.original branch
    if size(s.sidecoords,3) > 0
        M = s.sidecoords - loop.sidecoords(:,:,ones(1,size(s.sidecoords,3)));
        for i = 1:size(M,3)
            v = sqrt(diag(M(:,:,i)*(M(:,:,i)')))';
            v5 = [v5 v(5)];
            if v(5) > mymax
                mymax = v(5);
                disp([mymax l i v]);
            end
        end
    end
end