function [ikDihBranch,aaDihBranch,aaCoordsMatOrder] = orderSolution(stepNum, numDeltaSol, ikDihBranch, aaDihBranch, ikDeltaDihedrals, aaDeltaDihedrals, aaCoordsMat)

colList = 1:numDeltaSol(stepNum);

if (stepNum > 1 & numDeltaSol(stepNum-1)>0)
    num0 = numDeltaSol(stepNum-1);
    num1 = numDeltaSol(stepNum);
    m1 = zeros(num0,1);
    ind1 = zeros(num0,1);
    m2 = zeros(num0,1);
    ind2 = zeros(num0,1);
    [prevInd] = find(ikDihBranch(1,:,stepNum-1));
    adjMatrix1 = zeros(num1,prevInd(end));
    adjMatrix2 = zeros(num1,prevInd(end));
    for k = 1:num0  % for each branch of prev step:
        for j = 1:num1
            var1 = norm(ikDihBranch(:,prevInd(k),stepNum-1)-ikDeltaDihedrals(:,j,stepNum));
            branchDev1(j,k,stepNum-1) = var1;
            branchDev2(j,k,stepNum-1) = abs(360-var1);
        end;
        if (branchDev1(1:num1,k, stepNum-1) > 90)
            branchDev1(:,k,stepNum-1) = branchDev2(:,k,stepNum-1);
        end;
        [m1(k),ind1(k)] = min(branchDev1(1:num1,k,stepNum-1));
        [m2(k),ind2(k)] = min(branchDev2(1:num1,k,stepNum-1));
        adjMatrix1(ind1(k),prevInd(k)) = m1(k);
        adjMatrix2(ind2(k),prevInd(k)) = m2(k);
    end;
    if (num0 == num1)
        for j = 1:num1
            if isequal(adjMatrix1(j,:), zeros(1,num0))
                [newval, newind] = min(branchDev1(j,:, stepNum-1));
                adjMatrix1(:,newind) = zeros(num1,1);
                adjMatrix1(j,newind) = newval;
            end;
        end;
    end;
    newCount = 0;
    newBranches = [];
    for j = 1:num1
        [non0Ind] = find(adjMatrix1(j,:));
        if isempty(non0Ind)
            newCount = newCount+1;
            newBranches(newCount) = j;
        else
            [val, path] = min(adjMatrix1(j,non0Ind));
            ikDihBranch(:,non0Ind(path),stepNum) = ikDeltaDihedrals(:,j,stepNum);
            aaDihBranch(:,non0Ind(path),stepNum) = aaDeltaDihedrals(:,j,stepNum);
            aaCoordsMatOrder(:,:,non0Ind(path),stepNum) = aaCoordsMat(:,:,j); 
        end;
    end;
    if (newCount>0)
        widthIkDih = size(ikDihBranch,2);
        shiftIndex = (1+widthIkDih):(widthIkDih+newCount);
        ikDihBranch(:,shiftIndex,stepNum) = ikDeltaDihedrals(:,newBranches,stepNum);
        aaDihBranch(:,shiftIndex,stepNum) = aaDeltaDihedrals(:,newBranches,stepNum);
        aaCoordsMatOrder(:,:,shiftIndex,stepNum) = aaCoordsMat(:,:,newBranches); 
    end;
else  % stepNum 1 
    ikDihBranch(:,colList,stepNum) = ikDeltaDihedrals(:,colList,stepNum);
    aaDihBranch(:,colList,stepNum) = aaDeltaDihedrals(:,colList,stepNum);
    aaCoordsMatOrder(:,:,colList,stepNum) = aaCoordsMat; 
end;  
