function oxCoords = oper_c2o(pCa,pC, pN)

deg = pi/180;

idealBondAng = 116.2*deg; % calpha-c-n angle
caCOAng = 120.8*deg;
nCOAng = 123.0*deg;
cOLen = 1.231;

z0 = pN-pC;
z0 = z0/norm(z0);
prevBond = pC-pCa;
prevBond = prevBond/norm(prevBond);
x0 = cross(prevBond,z0); x0 = x0/norm(x0);
y0 = cross(z0,x0); y0 = y0/norm(y0);
cFrame = [x0', y0', z0', pC'; 0 0 0 1];

bondAng = pi-acos(dot(z0,prevBond)); 
deltaAng = bondAng-idealBondAng;

% c2oFrame = cFrame*dh4(0, -(caCOAng-deltaAng/2), 0, 0);
c2oFrame = cFrame*dh4(0, -nCOAng+deltaAng/2, 0,0);
oxCoords = c2oFrame*[0 0 cOLen 1]';
oxCoords = oxCoords(1:3)';

