function hydCoords = oper_n2h(pC,pN,pCa)
deg = pi/180;

idealBondAng = 121.7*deg;  % (c-n-calpha) angle
cNHAng = 123.8*deg;
caNHAng = 114.4*deg;
nHLen = 1.00;

z0 = pCa-pN;
z0 = z0/norm(z0);
prevBond = pC-pN;
prevBond = prevBond/norm(prevBond);
x0 = cross(prevBond,z0); x0 = x0/norm(x0);
y0 = cross(z0,x0); y0 = y0/norm(y0);
nFrame = [x0', y0', z0', pN'; 0 0 0 1];

bondAng = acos(dot(z0,prevBond));
deltaAng = bondAng-idealBondAng;

n2hFrame = nFrame*dh4(0, caNHAng-deltaAng/2, 0, 0);
hydCoords = n2hFrame*[0 0 nHLen 1]';
hydCoords = hydCoords(1:3)';
